createlib "PARAFAX"
  Release Vars All
  Release Procs All
  AltSpace {DeskTop} {Empty}
  Echo Normal
  Echo Off
;---------------------------------------
Proc Mainmenu()
  Splash()
  Displaymainmenu()
  Departing=False
  FaxBoard=True
While (Departing <> True)
   GetMenuSelection to menuitemselected
   Switch
    Case (Menuitemselected="Exit/Yes"):
         Departing=True
    Case (Menuitemselected="Exit/No"):
         Departing=False
    Case (Menuitemselected="Send Fax"):
         EditTable("Customer")
    Case (Menuitemselected="CoverSheet"):
         Showfiles "C:\\parafax\\*.r?" "Select Cover Sheet Report"
          To CoverSelection
    Case (Menuitemselected="DocumentSheet"):
         Showfiles "C:\\parafax\\*.r?" "Select Cover Sheet Report"
          To DocumentSelection
    Case (Menuitemselected="Fax Log/Print"):
      if IsPrinterReady() then
         Filewrite "Log.bat" from "Cd\\ql2fax \n"
         Filewrite append "Log.bat" from "type sndfax.log > lpt1 \n"
         Filewrite append "Log.bat" from "cd\\parafax"
         run norefresh "log.bat"
      endif
    Case (Menuitemselected="FaxBoard"):
      FaxBoard=True
    Case (Menuitemselected="PrinterOut"):
      FaxBoard=False   
   Endswitch
EndWhile    
Endproc
writelib "parafax" mainmenu    
;----------------------------------------------
Proc Splash()
  ShowPullDown EndMenu
  Dynarray SplashAttributes[]
    SplashAttributes["ORIGINROW"]=24
    SplashAttributes["ORIGINCOL"]=13
    SplashAttributes["WIDTH"]=56
    SplashAttributes["HEIGHT"]=15
    SplashAttributes["STYLE"]=30
    SplashAttributes["FLOATING"]=TRUE
    SplashAttributes["HASFRAME"]=FALSE
  Window Create Attributes SplashAttributes to SplashWindow
  @2,0 ?? Format("W56,AC"," P A R A F A X  ")
  @4,0 ?? Format("W56,AC","D A T A B A S E   F A X   S Y S T E M")
  Style Attribute 31 
  @6,0 ?? Format("W56,AC","V E R S I O N  2.5")
  @9,0 ?? Format("W56,AC","Written By Michael A.Amigoni")
  @10,0 ?? Format("W56,AC", "816-931-7002")
  Timersecs=150  
  Timersecs2=50
  For t from 24 to 7 step -1
      Window move SplashWindow to t,13
      Sleep Timersecs
  Endfor        
  Sleep 2000
  For tt from 13 to 80 step 1
      Window move SplashWindow to t+1,tt
      Sleep Timersecs2
  EndFor    
  window close
Endproc
writelib "parafax" Splash  
;--------------------------------------------------
Proc Greyoutmenu()
  MenuDisable "File"
  MenuDisable "SendFax"
  MenuDisable "Reports"
  MenuDisable "Exit"
Endproc
writelib "parafax" greyoutmenu  
;--------------------------------------------------  
Proc Greyinmenu()
  MenuEnable "File"
  MenuEnable "SendFax"
  MenuEnable "Reports"
  MenuEnable "Exit"
Endproc
writelib "parafax" greyinmenu  
;--------------------------------------------------
Proc DisplayMainmenu()
 Showpulldown
  
 "File": "Open Files":"File"
   SubMenu
     "Select Cover Sheet":"Choose Cover Sheet Report":"CoverSheet",
     "Select Document Sheet":"Choose Document Sheet Report":"DocumentSheet",
     "Destination":"Choose Fax Destination":"Fax/Print"
      SubMenu
      "Fax Board":"Use Fax Board for Output":"FaxBoard",
      "Printer":"Use Printer for Output":"PrinterOut"
      EndSubmenu
   EndSubMenu,

 "Send Faxes": "Send or Select Faxes":"SendFax"
   SubMenu
      "Send Fax/Mark Faxes":"Send Fax Activity":"Send Fax"
   EndSubmenu,
       
 "Reports":"":"Reports"
   SubMenu
      "Print Fax Log":"Print Fax Log Activity":"Fax Log/Print"
   EndSubmenu,

 
 "Exit":"Exit this Application":"Exit"
    SubMenu
       "No": "Do Not Exit Application":"Exit/No",
      "Yes": "Exit this Application": "Exit/Yes"
    EndSubMenu 

 EndMenu
Endproc 
writelib "parafax" displaymainmenu
;--------------------------------------------
Proc EditTable(tbl)
  GreyOutmenu()
  CoEdit tbl
 Window Handle Current to tablehandle 
  Pickform 1 
 Window Handle Form to formhandle
 SetHighLight Current Field 79
 While (True)
  Wait Table
   Prompt "[F5]-Send Faxes,[F7]-Mark/UnMark Record,[F8]-UnMark All,[F9]-Exit, Esc-Quit"
   Message "Edit Mode"
   Until
   "F9","F8","F7","F5", "Del","Esc"
   If Retval="F5" then
     SendFax()
   Endif   
   If Retval="F7" then
      if [fax check]="" then
         [fax check]=""
      else
         [fax check]=""
      endif          
   Endif
   If Retval="F8" then
    recnumber=recno()
      Scan
       [fax check]=""
      EndScan
    moveto record recnumber  
   Endif
   If Retval="F9" then
      Do_it! Quitloop
   Endif 
   If Retval="Esc" then
     If Menuprompt() <> "Value:" then
      Do_it! Quitloop 
     Else
      Keypress "Esc"
     Endif
   Endif   
   If Retval="Del" then
     DeleteOk()
   Endif  
 EndWhile
 Greyinmenu()
 window select formhandle
 window close
 window select tablehandle
 window close
 echo normal
 echo off 
Endproc
writelib "parafax" EditTable         
;-------------------------------------------------
Proc IsPrinterReady()
Message "Checking Printer Status.."
If Printerstatus() <> True then
   Beep
   Message "Printer is not Ready"
   Sleep 2000
   Message ""
   Return False
Else
   Message ""
   Return True
Endif
Endproc
writelib "parafax" IsPrinterReady
;-----------------------------------------
Proc DeleteOk()
Beep
ShowDialog "Delete Record?"
 @10,50 Height 5 Width 28
 Style Attribute 116
 @0,19 ?? "Tab \027 \026"
 PushButton
  @1,3 Width 6
  "~O~k"
  OK
  Default
  Value "DeleteOk"
  Tag "Delete.1"
  to  Deletebutton
 PushButton
   @1,11 Width 9
   "~C~ancel"
   CANCEL
  Value "DeleteCancel"
  Tag "Delete.2"
  to Deletebutton 
EndDialog 
  If Retval=True then
   Del
  Else
   Message "Cancelled Record Delete"
   Sleep 750
   Message ""
  Endif
EndProc
writelib "parafax" DeleteOk
;------------------------------------------   

Proc Sendfax()
 Message "Preparing Faxes.."
 if not isassigned(coverselection) then
    Beep
    Message "You Must Select a Cover Sheet Report"
    Sleep 2000
    return
 endif
 if not isassigned(documentselection) then
    Beep
    Message "You Must Select a Document Sheet Report"
    Sleep 2000
    return
 endif
 
  Do_it!
  {Ask} Select "Customer"
  CtrlHome Check
  [Fax Check]="\"\""
  Do_it!

if Isempty("answer") then
   Message "You Must \251 at Least One Record to Fax"
   beep
   sleep 2000
   Message ""
   clearimage
   upimage
   clearimage
   pickform 1
   coeditkey
   Return
endif   
   clearimage
   upimage
   clearimage
if not match(coverselection,"..\".\"..",covertable,coverReport) then
   Message "Sorry, cannot process cover report"
   sleep 2000
   Message ""
   Return
endif
if not match(documentselection,"..\".\"..",documentTable,documentReport) then
   Message "Sorry, cannot process document report"
   Sleep 2000
   Message ""
   Return
endif
if len(coverReport)=2 then 
   coverReport=substr(coverReport,2,1)
endif
if len(coverReport)=3 then
   coverReport=substr(coverReport,2,2)
endif
if len(documentReport)=2 then 
   documentReport=substr(documentReport,2,1)
endif
if len(documentReport)=3 then
   documentReport=substr(documentReport,2,2)
endif

   copy "answer" "faxtemp"
   recs=nrecords("Answer")
   batchcounter=0
for faxloop from 1 to recs
   empty "faxtemp"
   view  "answer"
   window handle current to AnswerHandle
   moveto record faxloop
   Message "Processing Faxes is ",int(recno()/recs * 100), "% Completed"
   copytoarray zz
   window select AnswerHandle 
   window close
   coedit "faxtemp"
   window handle current to FaxtempHandle
   moveto record 1
   copyfromarray zz
   faxnumber=[customer fax]
   do_it!
   window select FaxTempHandle
   window close
copyreport covertable coverReport "faxtemp" "1"
copyreport documentTable DocumentReport "faxtemp" "2"
if Faxboard=false then
   report "Faxtemp" "1"
   report "Faxtemp" "2"
   message ""
   pickform 1
   coeditkey
   Return
endif
run norefresh "del cover.pcl >nul"
run norefresh "del document.pcl >nul"
{report} {output}{faxtemp}{1}{file}{cover.pcl}
{Report}{RangeOutput}{faxtemp}{2}{File}{document.pcl}{1}{1}
document="copy cover.pcl+document.pcl C:\\ql2fax\\faxout"
    +strval(faxloop)+".pcl "
execute "run norefresh document"
filewrite "convert.bat" from "cd\\ql2fax \n"
filewrite append "convert.bat" from  "c:\\ql2fax\\convert faxout"+
                            strval(faxloop)+".pcl /PCL >nul \n"
filewrite append "convert.bat" from "cd\\parafax"                            
run norefresh "convert.bat"
filewrite "faxit.bat" from "cd\\ql2fax \n"
filewrite append "faxit.bat" from "c:\\ql2fax\\sndfax faxout"+
                                   strval(faxloop)+".qfx /N"+faxnumber+
                                   " \n"
filewrite append "faxit.bat" from "cd\\parafax"
run norefresh "faxit.bat"

Endfor
message ""
pickform 1
coeditkey
Endproc
writelib "parafax" sendfax

autolib= "parafax"
MainMenu()
